﻿-- HSTORE.SQL
Drop Table If Exists tUtiliseHSTORE ;
Drop Extension HSTORE ;

-- On doit impérativement ajouter l'extension HSTORE à postgres
Create Extension HSTORE ;

-- Création de la table
Create Table tUtiliseHSTORE (
	iId serial Constraint tUtiliseHSTORE_pk PRIMARY KEY
	, hValeurHSTORE HSTORE
	) ;

-- Insertion de données
INSERT INTO tUtiliseHSTORE (hValeurHSTORE) VALUES
	('"Nom"=>"Rencontres AtoutBox"
		, "Début"=>"15 mars 2018"
		, "Fin"=>"16 mars 2018"
		, "URL"=>"http://www.atoutfox.org/dates_rencontres_atoutfox_2018-programme.asp"'
		) ;

-- Lecture des données
Select * From  tUtiliseHSTORE ;
Select iId, hValeurHSTORE->'Nom' AS Nom, hValeurHSTORE->'Début' AS Début, hValeurHSTORE->'Fin' AS Fin From tUtiliseHSTORE ;

-- Mise à jour des données : opérateur ||, fusion de 2 hstores
Update tUtiliseHSTORE set hValeurHSTORE = hValeurHSTORE || ('Nom=>"Rencontres AtoutFox"') Where iId = 1 ;
Select * From  tUtiliseHSTORE ;

-- Ajout d'une propriété : idem
Update tUtiliseHSTORE set hValeurHSTORE = hValeurHSTORE || ('Lieu=>"Hotel IBIS Lyon Perrache"') Where iId = 1 ;
Select * From  tUtiliseHSTORE ;

-- Mise à jour des données : suppression de propriété
Update tUtiliseHSTORE set hValeurHSTORE = delete(hValeurHSTORE, 'Début') Where iId = 1 ;
Select * From  tUtiliseHSTORE ;

-- Insérer quelques lignes
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Insert Into tUtiliseHSTORE (hValeurHSTORE) Select hValeurHSTORE || ('Id=>' || currval('tutilisehstore_iid_seq') + 1)::hstore From tUtiliseHSTORE ;
Select Count(*) From tUtiliseHSTORE ;

-- Rechercher et indexer
Select * From tUtiliseHSTORE Where hValeurHSTORE->'Id' = '200000' ;			-- 150ms
Select * From tUtiliseHSTORE Where hValeurHSTORE @> 'Id=>200000' ;			-- idem
Select iId From tUtiliseHSTORE Where iId = 200000 ;
Select * From tUtiliseHSTORE Where Not hValeurHSTORE ? 'Id' ;				


-- CREATE INDEX idx_IdDansHSTORE ON tUtiliseHSTORE (hValeurHSTORE->'Id'); 	-- Ne fonctionne pas : pas indexable sur le contenu
CREATE INDEX idx_HSTORE ON tUtiliseHSTORE USING GIST (hValeurHSTORE);		-- Très long
Select * From tUtiliseHSTORE Where hValeurHSTORE @> 'Id=>200000' ;			-- 13ms
