* JSONB3.PRG
* Renormalisation du JSONB par une vue Postgres avec Trigger Instead Of et vue VFP
Set Default To "D:\Luc\Dev\Tlcharg et outils\AtoutFox Rencontres\2018\noSQL\VFP\"
Clear
Close Databases all
Set Safety Off

Local lcCnxnString, liCnxnHndl, laErr[1], liResultat, lcSQL

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Se connecter  PG
m.lcCnxnString = [DRIVER={] + "PostgreSQL Unicode" + [};] ;
					+ [SERVER=]+ "127.0.0.1" +[;] ;
					+ [DATABASE=] + "AtoutFox_2018" +[;] ;
					+ [PORT=] + "5432" +[;] ;
					+ [UID=] + "AtoutFox" +[;] ;
					+ [PWD=] + "mdp" + [;] ;
					+ [B9=0]

m.liCnxnHndl = SQLStringConnect(m.lcCnxnString)
If m.liCnxnHndl <= 0
	AError(m.laErr)
	MessageBox("Echec de la connexion : " + m.laErr[1, 2])
	Return 
Else
 	MessageBox("Connexion OK")
Endif

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Crer une vue Postgres
Text To m.lcSQL NoShow
	Create Or Replace View vUtiliseJSONBNormalise
		AS SELECT iid
			, jValeurJSONB->>'Nom' As Nom
			, jValeurJSONB->>'Dbut' As Dbut
			, jValeurJSONB->>'Fin' As Fin
			, jValeurJSONB->>'URL' As URL
			, jValeurJSONB->>'Sessions' As Sessions
 		FROM tUtiliseJSONB
EndText
m.liResultat = SQLExec(m.liCnxnHndl, m.lcSQL)
If m.liResultat <= 0
	AError(m.laErr)
	MessageBox("Echec de la cration de la vue Postgres : " + m.laErr[1, 2])
	Return 
Endif

* Test de la vue PG
m.liResultat = SQLExec(m.liCnxnHndl, "Select * From vUtiliseJSONBNormalise Where iId < 10 ;", "MonCurseur")
If m.liResultat <= 0
	AError(m.laErr)
	MessageBox("Echec de l'utilisation de la vue Postgres : " + m.laErr[1, 2])
	Return 
Endif
Select MonCurseur
Browse
Use

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Crer un trigger Instead Of BASIQUE sur la vue Postgres
Text To m.lcSQL NoShow
	--&& Crer la fonction qui s'excutera lors de l'vnement
	Create Or Replace Function fTrigIO_vUtiliseJSONBNormalise()
		Returns Trigger AS $$
	Begin
		Raise Info 'Je suis la preuve vivante que le trigger se dclenche' ; 
		Return new ;
	End ; $$ Language plpgSQL ;
	
	--&& Crer le gestionnaire d'vnement
	Drop Trigger If Exists TrigIO_vUtiliseJSONBNormalise On vUtiliseJSONBNormalise ;
	Create Trigger TrigIO_vUtiliseJSONBNormalise
		Instead Of Insert Or Update Or Delete On vUtiliseJSONBNormalise
		For Each Row
		Execute Procedure fTrigIO_vUtiliseJSONBNormalise() ;
EndText
m.liResultat = SQLExec(m.liCnxnHndl, m.lcSQL)
If m.liResultat <= 0
	AError(m.laErr)
	MessageBox("Echec de la cration du trigger Instead Of : " + m.laErr[1, 2])
	Return 
Endif
* A excuter sous PGAdmin pour voir le message
*!*	Update vUtiliseJSONBNormalise Set Nom = 'Rencontres AtoutFox 2' Where iId = 1 ;

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Crer un trigger Instead Of plus complet sur la vue Postgres
Text To m.lcSQL NoShow
	--&& Crer la fonction qui s'excutera lors de l'vnement
	Create Or Replace Function fTrigIO_vUtiliseJSONBNormalise()
		Returns Trigger AS $$
	Declare
		lsJSON Text = '' ;
	Begin
		if TG_OP = 'UPDATE' Then
			--&& Cas d'une modification
			if New.Nom Is Distinct From Old.Nom Then
				--&& Le nom a chang
				Raise Info 'Je suis la preuve vivante que le trigger se dclenche uniquement quand le nom a chang' ; 
				lsJSON = '{"Nom":"' || New.Nom || '"}' ;
			End If ;
		End If ;
		
		If lsJSON != '' Then
			--&& Il y a eu une modification
			--&& Il faut mettre  jour la table associe
			Update tUtiliseJSONB
				Set jValeurJSONB = jValeurJSONB || lsJSON::JSONB
				Where iId = New.iId ;
		End if ;
				
		Return new ;
	End ; $$ Language plpgSQL ;
	
	--&& Crer le gestionnaire d'vnement
	Drop Trigger If Exists TrigIO_vUtiliseJSONBNormalise On vUtiliseJSONBNormalise ;
	Create Trigger TrigIO_vUtiliseJSONBNormalise
		Instead Of Insert Or Update Or Delete On vUtiliseJSONBNormalise
		For Each Row
		Execute Procedure fTrigIO_vUtiliseJSONBNormalise() ;
EndText
m.liResultat = SQLExec(m.liCnxnHndl, m.lcSQL)
If m.liResultat <= 0
	AError(m.laErr)
	MessageBox("Echec de la cration du trigger Instead Of : " + m.laErr[1, 2])
	Return 
Endif
* A excuter sous PGAdmin pour voir le message
*!*	Update vUtiliseJSONBNormalise Set Nom = 'Rencontres AtoutFox 2' Where iId = 1 ;
* On peut aussi faire ca depuis VFP : 
m.liResultat = SQLExec(m.liCnxnHndl, "Update vUtiliseJSONBNormalise Set Nom = 'Rencontres AtoutFox 3' Where iId = 1 ;")
If m.liResultat <= 0
	AError(m.laErr)
	MessageBox("Echec du Update : " + m.laErr[1, 2])
	Return 
Endif
m.liResultat = SQLExec(m.liCnxnHndl, "Select * From vUtiliseJSONBNormalise Where iId < 10 ;", "MonCurseur")
If m.liResultat <= 0
	AError(m.laErr)
	MessageBox("Echec de l'utilisation de la vue Postgres : " + m.laErr[1, 2])
	Return 
Endif
Select MonCurseur
Browse
Use
Return 

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Enfin, crer une vue VFP sur la vue Postgres
Open Database noSQL
Create Connection maConnexion Connstring m.lcCnxnString
Create Sql View vUtiliseJSONBNormalise ;
	Connection maConnexion ;
	AS SELECT iid, Nom As Nom ;
 		FROM vUtiliseJSONBNormalise ;
 		Where iId < 10

DBSetProp("vUtiliseJSONBNormalise","View","SendUpdates",.T.)
DBSetProp("vUtiliseJSONBNormalise","View","BatchUpdateCount",1)
DBSetProp("vUtiliseJSONBNormalise","View","CompareMemo",.T.)
DBSetProp("vUtiliseJSONBNormalise","View","FetchAsNeeded",.F.)
DBSetProp("vUtiliseJSONBNormalise","View","FetchMemo",.T.)
DBSetProp("vUtiliseJSONBNormalise","View","FetchSize",100)
DBSetProp("vUtiliseJSONBNormalise","View","MaxRecords",-1)
DBSetProp("vUtiliseJSONBNormalise","View","Prepared",.F.)
DBSetProp("vUtiliseJSONBNormalise","View","ShareConnection",.F.)
DBSetProp("vUtiliseJSONBNormalise","View","AllowSimultaneousFetch",.F.)
DBSetProp("vUtiliseJSONBNormalise","View","UpdateType",1)
DBSetProp("vUtiliseJSONBNormalise","View","UseMemoSize",255)
DBSetProp("vUtiliseJSONBNormalise","View","Tables","vUtiliseJSONBNormalise")
DBSetProp("vUtiliseJSONBNormalise","View","WhereType",3)

DBSetProp("vUtiliseJSONBNormalise"+".iid","Field","DataType","I")
DBSetProp("vUtiliseJSONBNormalise"+".iid","Field","UpdateName","vUtiliseJSONBNormalise.iid")
DBSetProp("vUtiliseJSONBNormalise"+".iid","Field","KeyField",.T.)
DBSetProp("vUtiliseJSONBNormalise"+".iid","Field","Updatable",.F.)

DBSetProp("vUtiliseJSONBNormalise"+".Nom","Field","DataType","M")
DBSetProp("vUtiliseJSONBNormalise"+".Nom","Field","UpdateName","vUtiliseJSONBNormalise.Nom")
DBSetProp("vUtiliseJSONBNormalise"+".Nom","Field","KeyField",.F.)
DBSetProp("vUtiliseJSONBNormalise"+".Nom","Field","Updatable",.T.)

Set Step On
* Ouvrir et faire une modification
Use vUtiliseJSONBNormalise
Browse Title "Faire une modification dans Nom, puis faite le TableUpdate en changeant de ligne"

* Vrifier que la modification a t enregisre
Use 
Use vUtiliseJSONBNormalise
Browse Title "Vrifier que la donne a bien t enregistre"


Close Databases All
