* JSONB.PRG
Set Default To "D:\Luc\Dev\Tlcharg et outils\AtoutFox Rencontres\2018\noSQL\VFP\"
Clear
Close Databases all
Set Safety Off

Local lcCnxnString, liCnxnHndl, laErr[1], liResultat

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Se connecter  PG
m.lcCnxnString = [DRIVER={] + "PostgreSQL Unicode" + [};] ;
					+ [SERVER=]+ "127.0.0.1" +[;] ;
					+ [DATABASE=] + "AtoutFox_2018" +[;] ;
					+ [PORT=] + "5432" +[;] ;
					+ [UID=] + "AtoutFox" +[;] ;
					+ [PWD=] + "mdp" + [;] ;
					+ [B9=0]

m.liCnxnHndl = SQLStringConnect(m.lcCnxnString)
If m.liCnxnHndl <= 0
	AError(m.laErr)
	MessageBox("Echec de la connexion : " + m.laErr[1, 2])
	Return 
Else
* 	MessageBox("Connexion OK")
Endif
Return


* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Requter la table : basique
m.liResultat = SQLExec(m.liCnxnHndl, "Select * From tUtiliseJSONB Where iId < 10", "monCurseur")
If m.liResultat <= 0
	AError(m.laErr)
	MessageBox("Echec de SQLExec : " + m.laErr[1, 2])
	Return 
Endif
Select monCurseur
Browse
use

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Requter la table : conversion du JSONB en texte
m.liResultat = SQLExec(m.liCnxnHndl, "Select iId, jValeurJSONB::Text From tUtiliseJSONB Where iId < 10", "monCurseur")
If m.liResultat <= 0
	AError(m.laErr)
	MessageBox("Echec de SQLExec : " + m.laErr[1, 2])
	Return 
Endif
Select monCurseur
Browse
Return 

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Lecture d'un document
Set Procedure To qdfoxjson.prg Additive 
Local lcDocument, loJSONHelper, loDocument
m.loJSONHelper = CreateObject("jsonHelper")
m.lojsonhelper.QuotePropertyNames = .T.
m.lojsonhelper.StringDelimitator = '"'
m.lcDocument = monCurseur.jValeurJSONB
m.loDocument = m.loJSONHelper.Parse(m.lcDocument)
Set Step On

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Requter la table : exploitation du JSONB ct PG
m.liResultat = SQLExec(m.liCnxnHndl, "Select iId, jValeurJSONB::Text, (jValeurJSONB->>'URL')::VarChar(100) As URL From tUtiliseJSONB Where jValeurJSONB->>'Id' = '200000'", "monCurseur")
If m.liResultat <= 0
	AError(m.laErr)
	MessageBox("Echec de SQLExec : " + m.laErr[1, 2])
	Return 
Endif
Select monCurseur
brow

* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
* Crer une vue
Open Database noSQL
Create Connection maConnexion Connstring m.lcCnxnString
Create Sql View vUtiliseJSONB ;
	Connection maConnexion ;
	AS SELECT iid, jValeurJSONB::Text;
 		FROM tUtiliseJSONB ;
 		Where iId < 10

DBSetProp("vUtiliseJSONB","View","SendUpdates",.T.)
DBSetProp("vUtiliseJSONB","View","BatchUpdateCount",1)
DBSetProp("vUtiliseJSONB","View","CompareMemo",.T.)
DBSetProp("vUtiliseJSONB","View","FetchAsNeeded",.F.)
DBSetProp("vUtiliseJSONB","View","FetchMemo",.T.)
DBSetProp("vUtiliseJSONB","View","FetchSize",100)
DBSetProp("vUtiliseJSONB","View","MaxRecords",-1)
DBSetProp("vUtiliseJSONB","View","Prepared",.F.)
DBSetProp("vUtiliseJSONB","View","ShareConnection",.F.)
DBSetProp("vUtiliseJSONB","View","AllowSimultaneousFetch",.F.)
DBSetProp("vUtiliseJSONB","View","UpdateType",1)
DBSetProp("vUtiliseJSONB","View","UseMemoSize",255)
DBSetProp("vUtiliseJSONB","View","Tables","tutilisejsonb")
DBSetProp("vUtiliseJSONB","View","WhereType",3)

DBSetProp("vUtiliseJSONB"+".iid","Field","DataType","I")
DBSetProp("vUtiliseJSONB"+".iid","Field","UpdateName","tutilisejsonb.iid")
DBSetProp("vUtiliseJSONB"+".iid","Field","KeyField",.T.)
DBSetProp("vUtiliseJSONB"+".iid","Field","Updatable",.F.)

DBSetProp("vUtiliseJSONB"+".jvaleurjsonb","Field","DataType","M")
DBSetProp("vUtiliseJSONB"+".jvaleurjsonb","Field","UpdateName","tutilisejsonb.jvaleurjsonb")
DBSetProp("vUtiliseJSONB"+".jvaleurjsonb","Field","KeyField",.F.)
DBSetProp("vUtiliseJSONB"+".jvaleurjsonb","Field","Updatable",.T.)

Use vUtiliseJSONB
Browse 

* -----------------------------------------------------------------------------------------------------------------------------------------------------------
* Mise  jour
Local loRec, lcNouvelleSession, loNouvelleSession
Scatter Name m.loRec Memo
m.lcDocument = m.loRec.jValeurJSONB
m.loDocument = m.loJSONHelper.Parse(m.lcDocument)
Set Step On

* Modification d'un document : ajout de proprit simple
AddProperty(m.loDocument, "Restaurant", "Georges")
* Modification d'un document : tableau
m.lcNouvelleSession = [{"Titre": "Introduction  l'intelligence artificielle", "Auteur": "Jean-Claude RIVIRE"}]
m.loNouvelleSession = m.loJSONHelper.Parse(m.lcNouvelleSession)
If Not PemStatus(m.loDocument, "Sessions", 5)
	* Crer la collection de sessions maintenant
	AddProperty(m.loDocument, "Sessions", CreateObject("Collection"))
Endif
m.loDocument.Sessions.Add(m.loNouvelleSession)

* Gnrer le JSON sous forme de texte
m.lcDocument = m.loJSONHelper.Encode(m.loDocument)
m.lcDocument = Strtran(m.lcDocument, "%DOUBLEQUOTE%", '"')
m.lcDocument = Strtran(m.lcDocument, "%SINGLEQUOTE%", "'")

* Envoyer  Postgres
Local lcSQL
Text To m.lcSQL Textmerge NoShow
	Update tUtiliseJSONB 
		Set jValeurJSONB = $JSONB$<<m.lcDocument>>$JSONB$::JSONB
		Where iId = <<m.loRec.iId>> ;
EndText
If SQLExec(m.liCnxnHndl, m.lcSQL) <= 0
	AError(m.laErr)
	MessageBox("Echec de SQLExec : " + m.laErr[1, 2])
Endif

* Rafraichir la vue et l'afficher
Requery("vUtiliseJSONB")
Modify Memo jValeurJSONB

Close Databases All